import { MutableRefObject, ForwardedRef, RefObject, CSSProperties } from 'react';
export interface ViewportListRef {
    scrollToIndex: (index?: number, alignToTop?: boolean, offset?: number) => void;
}
export interface ViewportListProps<T> {
    viewportRef?: MutableRefObject<HTMLElement | null> | RefObject<HTMLElement | null> | {
        current: HTMLElement | null;
    };
    items?: T[];
    itemMinSize?: number;
    margin?: number;
    overscan?: number;
    axis?: 'y' | 'x';
    initialIndex?: number;
    initialAlignToTop?: boolean;
    initialOffset?: number;
    children: (item: T, index: number, array: T[]) => any;
    onViewportIndexesChange?: (viewportIndexes: [number, number]) => void;
    overflowAnchor?: 'none' | 'auto';
    withCache?: boolean;
    scrollThreshold?: number;
    spacerElement?: keyof JSX.IntrinsicElements;
    spacerStyle?: CSSProperties;
}
declare const ViewportListInner: <T>({ viewportRef, items, itemMinSize, margin, overscan, axis, initialIndex, initialAlignToTop, initialOffset, children, onViewportIndexesChange, overflowAnchor, withCache, scrollThreshold, spacerElement, spacerStyle, }: ViewportListProps<T>, ref: ForwardedRef<ViewportListRef>) => JSX.Element;
export declare const ViewportList: <T>(props: ViewportListProps<T> & {
    ref?: ForwardedRef<ViewportListRef> | undefined;
}) => ReturnType<typeof ViewportListInner>;
export default ViewportList;
